#include <iostream>
#include <vector>
using namespace std;
int r,c,m;
vector<string> grid;
bool valid_pos(int i, int j){
    return !(i < 0 || j < 0 || i >= r || j >= c || grid[i][j] == '#');
}
int main(){
    cin >> r >> c >> m;
    grid.resize(r);
    for(int i = 0; i < r; ++i)
        cin >> grid[i];
    string msg;
    cin >> msg;
    int ans = 0;
    for(int i = 0; i < r; ++i){
        for(int j = 0; j < c; ++j){
            int x = i, y = j;
            bool ok = valid_pos(i,j);
            if(ok){
                for(char w : msg){
                    if(w == 'W')
                        y -= 1;
                    if(w == 'E')
                        y += 1;
                    if(w == 'N')
                        x -= 1;
                    if(w == 'S')
                        x += 1;
                    if(!valid_pos(x,y)){
                        ok = false;
                        break;
                    }
                }
            }
            ans += ok;
        }
    }
    cout << ans << '\n';
}
