#include <iostream>
#include <vector>
#include <bitset>
using namespace std;
int r,c,m;
vector<string> grid;
int main(){
    cin >> r >> c >> m;
    grid.resize(r);
    for(int i = 0; i < r; ++i)
        cin >> grid[i];
    string msg;
    cin >> msg;
    vector<vector<int> > reach(r),tmp(r),sea(r);
    for(int i = 0; i < r; ++i){
        reach[i] = tmp[i] = sea[i] = vector<int>(c);
        for(int j = 0; j < c; ++j){
            sea[i][j] = grid[i][j] == '.';
            reach[i][j] = grid[i][j] == '.';
        }
    }
    for(char w : msg){
        if(w == 'W'){
            for(int i = 0; i < r; ++i){
                for(int j = 0; j < c-1; ++j){
                    reach[i][j] = reach[i][j+1] & sea[i][j];
                }
                reach[i][c-1] = 0;
            }
        }
        if(w == 'E'){
            for(int i = 0; i < r; ++i){
                for(int j = c-1; j > 0; --j){
                    reach[i][j] = reach[i][j-1] & sea[i][j];
                }
                reach[i][0] = 0;
            }
        }
        if(w == 'N'){
            for(int i = 0; i < r; ++i){
                if(i < r-1)
                    for(int j = 0; j < c; ++j)
                        reach[i][j] = reach[i+1][j] & sea[i][j];
                else
                    for(int j = 0; j < c; ++j)
                        reach[i][j] = 0;
            }
        }
        if(w == 'S'){
            for(int i = r-1; i >= 0; --i){
                if(i > 0)
                    for(int j = 0; j < c; ++j)
                        reach[i][j] = reach[i-1][j] & sea[i][j];
                else
                    for(int j = 0; j < c; ++j)
                        reach[i][j] = 0;
            }
        }
        if(w == '?'){
            for(int i = 0; i < r; ++i)
                for(int j = 0; j < c; ++j)
                    tmp[i][j] = 0;
            for(int i = 0; i < r; ++i)
                for(int j = 0; j < c; ++j){
                    if(i > 0) tmp[i][j] |= reach[i-1][j];
                    if(i < r-1) tmp[i][j] |= reach[i+1][j];
                    if(j > 0) tmp[i][j] |= reach[i][j-1];
                    if(j < c-1) tmp[i][j] |= reach[i][j+1];
                    tmp[i][j] &= sea[i][j];
                }
            for(int i = 0; i < r; ++i)
                for(int j = 0; j < c; ++j)
                    reach[i][j] = tmp[i][j];
        }
    }
    int ans = 0;
    for(int i = 0; i < r; ++i)
        for(int j = 0; j < c; ++j)
            ans += reach[i][j];
    cout << ans << '\n';
}
