import sys

maxn = 1005

grid = [0 for i in range(maxn)]
possibles = [[0 for i in range(maxn)],
             [0 for i in range(maxn)]]

line = sys.stdin.readline().strip().split(" ")
height = int(line[0])
width = int(line[1])
message = int(line[2])

for i in range(1, height + 1):
    row = sys.stdin.readline().strip();
    for j in range(width - 1, -1, -1):
        grid[i] *= 2
        if row[j] == '.':
            grid[i] += 1
    grid[i] *= 2

for i in range(1, height + 1):
    possibles[1][i] = grid[i]

msg = sys.stdin.readline().strip()
for i in range(message):
    c = msg[i]
    if c == 'N':
        for k in range(1, height + 1):
            possibles[i % 2][k] = possibles[((i + 1) & 1)][k + 1] & grid[k]
    elif c == 'E':
        for k in range(1, height + 1):
            possibles[i % 2][k] = (possibles[((i + 1) & 1)][k] << 1) & grid[k]
    elif c == 'S':
        for k in range(1, height + 1):
            possibles[i % 2][k] = possibles[((i + 1) & 1)][k - 1] & grid[k]
    elif c == 'W':
        for k in range(1, height + 1):
            possibles[i % 2][k] = (possibles[((i + 1) & 1)][k] >> 1) & grid[k]
    elif c == '?':
        for k in range(1, height + 1):
            possibles[i % 2][k] = (possibles[((i + 1) & 1)][k + 1] |
                                   (possibles[((i + 1) & 1)][k] << 1) |
                                   possibles[((i + 1) & 1)][k - 1] |
                                   (possibles[((i + 1) & 1)][k] >> 1)) & grid[k]

ans = 0
for i in range(1, height + 1):
    cur = possibles[(message - 1) % 2][i]
    while cur != 0:
        if cur & 1:
            ans += 1
        cur >>= 1

print(ans)
