import sys
from array import array


def solve_noflip(s, t, loc):
	n, m = len(s), len(t)
	res = 0
	cur_h_len = array('h')
	forw_back_len = array('h')
	back_forw_len = array('h')
	for i in range(m + 1):
		cur_h_len.append(0)
		forw_back_len.append(0)
		back_forw_len.append(0)
	cur_v_len = array('h') # offset -n
	cur_v_y = array('h')
	for i in range(n+m + 1):
		cur_v_len.append(0)
		cur_v_y.append(0)
	for i in range(n + 1):
		cur_v_y[n - i] = i
	for i in range(n + 1):
		for j in range(m + 1):
			if(forw_back_len[j] > 0):
				forw_back_len[j] -= 1
		for j in range(m + 1):
			idx = n - i + j
			while cur_v_y[idx] - cur_v_len[idx] == i:
				y = cur_v_y[idx]
				# x-j == y-i
				x = y - i + j
				if(cur_v_len[idx] > forw_back_len[x]):
					forw_back_len[j] = cur_v_len[idx]
				if y == n or x == m:
					cur_v_y[idx] = -1
				else:
					cur_v_y[idx] += 1
					if s[y] == t[x]:
						cur_v_len[idx] += 1
					else:
						cur_v_len[idx] = 0
		for j in range(m + 1):
			back_forw_len[j] = 0
		for j in range(m + 1):
			nj = j - cur_h_len[j]
			if(cur_h_len[j] > back_forw_len[nj]):
				back_forw_len[nj] = cur_h_len[j]
		for j in range(1, m + 1):
			if(back_forw_len[j - 1] > back_forw_len[nj]):
				back_forw_len[nj] = back_forw_len[j - 1] - 1
		for j in range(m + 1):
			if forw_back_len[j] + back_forw_len[j] > res:
				res = forw_back_len[j] + back_forw_len[j]
				loc[0] = i - back_forw_len[j]
				loc[1] = j - forw_back_len[j]
		if i < n:
			for j in range(m - 1, -1, -1):
				if s[i] == t[j]:
					cur_h_len[j + 1] = cur_h_len[j] + 1
				else:
					cur_h_len[j + 1] = 0
			cur_h_len[0] = 0
	return res

def solve(s, t, loc):
	loc_noflip = [0, 0]
	res = solve_noflip(s, t, loc_noflip)
	loc_flip = [0, 0]
	res_flip = solve_noflip(s, t[::-1], loc_flip)
	if res_flip > res:
		res = res_flip
		loc[0] = loc_flip[0]
		loc[1] = len(t) - loc_flip[1] - res
	else:
		loc[0] = loc_noflip[0]
		loc[1] = loc_noflip[1]
	return res

s = sys.stdin.readline().strip()
t = sys.stdin.readline().strip()
loc = [0, 0]
res = solve(s, t, loc)
sys.stdout.write('{0}\n'.format(res));
if res > 0:
	sys.stdout.write('{0} {1}\n'.format(loc[0], loc[1]))
