import sys
import time
import random

mod = int(1e9 + 7)
mult = 257
nmax = int(3e3 + 5)

mult_pow = [1]
for i in range(nmax):
	mult_pow.append(mult_pow[-1]*mult%mod)

def solve_noflip(a, b, loc):
	c_end = time.process_time()+7.45
	s = [a, b]
	n = [len(a), len(b)]
	l = [0, 0]
	r = [0, 0]
	res = 0
	while time.process_time() < c_end:
		for i in range(2):
			l[i] = random.randint(0, n[i]-1)
			r[i] = l[i]
		if 2 * (min(l[0], l[1]) + min(n[0] - r[0], n[1] - r[1])) <= res: continue
		while min(l[0], l[1]) > 0 and s[0][l[0] - 1] == s[1][l[1] - 1]:
			l[0] -= 1
			l[1] -= 1
		if 2 * (r[0] - l[0] + min(n[0] - r[0], n[1] - r[1])) <= res: continue
		while r[0] < n[0] and r[1] < n[1] and s[0][r[0]] == s[1][r[1]]:
			r[0] += 1
			r[1] += 1
		length = r[0] - l[0]
		if 2 * length <= res: continue
		if length > res:
			res = length
			loc[0] = l[0]
			loc[1] = l[1]
		for i in range(2):
			h = [0, 0]
			for j in range(1, min(length, min(n[i] - r[i], l[1-i]))+1):
				h[i] += ord(s[i][r[i] + j - 1]) * mult_pow[j - 1]
				h[i] %= mod
				h[1-i] *= mult
				h[1-i] += ord(s[1-i][l[1-i] - j])
				h[1-i] %= mod
				if j > res - length and h[0] == h[1]:
					res = length + j
					loc[i] = l[i]
					loc[1-i] = l[1-i] - j
	return res

def solve(s, t, loc):
	loc_noflip = [0, 0]
	res = solve_noflip(s, t, loc_noflip)
	loc_flip = [0, 0]
	res_flip = solve_noflip(s, t[::-1], loc_flip)
	if res_flip > res:
		res = res_flip
		loc[0] = loc_flip[0]
		loc[1] = len(t) - loc_flip[1] - res
	else:
		loc[0] = loc_noflip[0]
		loc[1] = loc_noflip[1]
	return res

s = sys.stdin.readline().strip()
t = sys.stdin.readline().strip()
loc = [0, 0]
res = solve(s, t, loc)
sys.stdout.write('{0}\n'.format(res));
if res > 0:
	sys.stdout.write('{0} {1}\n'.format(loc[0], loc[1]))
