import sys
import time
import random


def solve_noflip(a, b, loc):
	c_end = time.process_time()+2.45
	s = [a, b]
	n = [len(a), len(b)]
	l = [0, 0]
	r = [0, 0]
	res = 0
	while time.process_time() < c_end:
		for i in range(2):
			l[i] = random.randint(0, n[i]-1)
			r[i] = l[i]
		if 2 * (min(l[0], l[1]) + min(n[0] - r[0], n[1] - r[1])) <= res: continue
		while min(l[0], l[1]) > 0 and s[0][l[0] - 1] == s[1][l[1] - 1]:
			l[0] -= 1
			l[1] -= 1
		if 2 * (r[0] - l[0] + min(n[0] - r[0], n[1] - r[1])) <= res: continue
		while r[0] < n[0] and r[1] < n[1] and s[0][r[0]] == s[1][r[1]]:
			r[0] += 1
			r[1] += 1
		length = r[0] - l[0]
		if length > res:
			res = length
			loc[0] = l[0]
			loc[1] = l[1]
	return res

def solve(s, t, loc):
	loc_noflip = [0, 0]
	res = solve_noflip(s, t, loc_noflip)
	loc_flip = [0, 0]
	res_flip = solve_noflip(s, t[::-1], loc_flip)
	if res_flip > res:
		res = res_flip
		loc[0] = loc_flip[0]
		loc[1] = len(t) - loc_flip[1] - res
	else:
		loc[0] = loc_noflip[0]
		loc[1] = loc_noflip[1]
	return res

s = sys.stdin.readline().strip()
t = sys.stdin.readline().strip()
loc = [0, 0]
res = solve(s, t, loc)
sys.stdout.write('{0}\n'.format(res));
if res > 0:
	sys.stdout.write('{0} {1}\n'.format(loc[0], loc[1]))
