#pragma GCC optimize("Ofast")
#include <stack>
#include <iomanip>
#include <algorithm>
#include <cassert>
#include <cstring>
#include <vector>
#include <utility>
#include <iostream>
#include <string>
#define pb push_back
#define all(v) (v).begin(), (v).end()
#define sz(v) ll(v.size())
#define T1 template<typename T> static
using namespace std;
typedef long long ll;
typedef vector<ll> vl;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
const ll INF = ll(2e18) + 666;
T1 ostream& operator<<(ostream& stream, const vector<T>& t);
T1 void print(T x, string end = "\n"){
    cout << x << end;
}
const int N = 101;
ll dist[N];
bool is_shop[N];
int n,e;
vpii edges;
vl weights;
void _(){
    int s,q;
    cin >> n >> s >> q >> e;
    for(int i = 0; i < n-1; ++i){
        int a,b,w;
        cin >> a >> b >> w;
        edges.pb({a,b});
        weights.pb(w);
    }
    for(int i = 0; i < s; ++i){
        int u;
        cin >> u;
        is_shop[u] = true;
    }
    for(int i = 0; i < q; ++i){
        int id,u;
        cin >> id >> u;
        --id;
        memset(dist,0x3f,sizeof dist);
        dist[u] = 0;
        while(true){
            bool changes = false;
            for(int i = 0; i < n-1; ++i){
                if(i == id) ++i;
                int x = edges[i].first, y = edges[i].second;
                if(dist[x] > dist[y]+weights[i]){
                    dist[x] = dist[y]+weights[i];
                    changes = true;
                }
                if(dist[y] > dist[x]+weights[i]){
                    dist[y] = dist[x]+weights[i];
                    changes = true;
                }
            }
            if(!changes)
                break;
        }
        //cout << dist[e] << '\n';
        if(dist[e] < dist[0])
            print("escaped");
        else{
            ll shop_dist = dist[0];
            for(int i = 1; i <= n; ++i)
                if(is_shop[i])
                    shop_dist = min(shop_dist,dist[i]);
            if(shop_dist < dist[0])
                print(shop_dist);
            else
                print("oo");
        }
    }
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(15);
        _();
    }
