// rename this file to nautilus.java before compiling

import java.util.*;
import java.math.*;
import java.util.stream.*;
import java.io.OutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.Arrays;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;
import java.io.BufferedReader;
import java.util.Comparator;
import java.util.Collections;
import java.io.InputStream;

public class nautilus{
    public static void main(String[] args){
        InputStream inputStream = System.in;
        OutputStream outputStream = System.out;
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        int R = in.nextInt(), C = in.nextInt(), M = in.nextInt();
        BigInteger[] sea = new BigInteger[R+2], reach = new BigInteger[R+2];
        BigInteger[] temp = new BigInteger[R+2];
        BigInteger two = new BigInteger("2");
        reach[0] = BigInteger.ZERO;
        reach[R+1] = BigInteger.ZERO;
        for(int i = 1; i <= R; ++i){
            sea[i] = BigInteger.ZERO;
            String line = in.next();
            for(int j = 0; j < C; ++j){
                sea[i] = sea[i].shiftLeft(1);
                if(line.charAt(j) == '.'){
                    sea[i] = sea[i].add(BigInteger.ONE);
                }
            }
            reach[i] = sea[i];
        }
        String path = in.next();
        for(int t = 0; t < M; ++t){
            char c = path.charAt(t);
            if(c == 'W'){
                for(int i = 1; i <= R; ++i){
                    reach[i] = (reach[i].shiftLeft(1)).and(sea[i]);
                }
            }
            if(c == 'E'){
                for(int i = 1; i <= R; ++i){
                    reach[i] = (reach[i].shiftRight(1)).and(sea[i]);
                }
            }
            if(c == 'N'){
                for(int i = 1; i <= R; ++i){
                    reach[i] = reach[i+1].and(sea[i]);
                }
                //reach[R] = BigInteger.ZERO;
            }
            if(c == 'S'){
                for(int i = R; i >= 1; --i){
                    reach[i] = reach[i-1].and(sea[i]);
                }
                //reach[0] = BigInteger.ZERO;
            }
            if(c == '?'){
                for(int i = 1; i <= R; ++i){
                    temp[i] = (reach[i].shiftLeft(1)
                        .or(reach[i].shiftRight(1))
                        .or(reach[i-1])
                        .or(reach[i+1]))
                        .and(sea[i]);
                }
                for(int i = 1; i <= R; ++i)
                    reach[i] = temp[i];
            }
        }
        int ans = 0;
        for(int i = 1; i <= R; ++i)
            ans += reach[i].bitCount();
        System.out.println(ans);
    }
    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream), 32768);
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }
    }
}
