// rename this file to nautilus.java before compiling

import java.util.*;

public class nautilus{
    public static void main(String[] args){
        Scanner in = new Scanner(System.in);
        int R = in.nextInt(), C = in.nextInt(), M = in.nextInt();
        int[][] sea = new int[R][C], reach = new int[R][C], temp = new int[R][C];
        for(int i = 0; i < R; ++i){
            String line = in.next();
            for(int j = 0; j < C; ++j){
                if(line.charAt(j) == '.')
                    sea[i][j] = 1;
                else
                    sea[i][j] = 0;
                reach[i][j] = sea[i][j];
            }
        }
        String path = in.next();
        for(int t = 0; t < M; ++t){
            char c = path.charAt(t);
            if(c == 'W'){
                for(int i = 0; i < R; ++i){
                    for(int j = 0; j < C-1; ++j){
                        reach[i][j] = reach[i][j+1] & sea[i][j];
                    }
                    reach[i][C-1] = 0;
                }
            }
            if(c == 'E'){
                for(int i = 0; i < R; ++i){
                    for(int j = C-1; j > 0; --j){
                        reach[i][j] = reach[i][j-1] & sea[i][j];
                    }
                    reach[i][0] = 0;
                }
            }
            if(c == 'N'){
                for(int i = 0; i < R; ++i){
                    if(i < R-1)
                        for(int j = 0; j < C; ++j)
                            reach[i][j] = reach[i+1][j] & sea[i][j];
                    else
                        for(int j = 0; j < C; ++j)
                            reach[i][j] = 0;
                }
            }
            if(c == 'S'){
                for(int i = R-1; i >= 0; --i){
                    if(i > 0)
                        for(int j = 0; j < C; ++j)
                            reach[i][j] = reach[i-1][j] & sea[i][j];
                    else
                        for(int j = 0; j < C; ++j)
                            reach[i][j] = 0;
                }
            }
            if(c == '?'){
                for(int i = 0; i < R; ++i)
                    for(int j = 0; j < C; ++j)
                        temp[i][j] = 0;
                for(int i = 0; i < R; ++i)
                    for(int j = 0; j < C; ++j){
                        if(i > 0) temp[i][j] |= reach[i-1][j];
                        if(i < R-1) temp[i][j] |= reach[i+1][j];
                        if(j > 0) temp[i][j] |= reach[i][j-1];
                        if(j < C-1) temp[i][j] |= reach[i][j+1];
                        temp[i][j] &= sea[i][j];
                    }
                for(int i = 0; i < R; ++i)
                    for(int j = 0; j < C; ++j)
                        reach[i][j] = temp[i][j];
            }
        }
        int ans = 0;
        for(int i = 0; i < R; ++i)
            for(int j = 0; j < C; ++j)
                ans += reach[i][j];
        System.out.println(ans);
    }
}
