import sys

maxn = 1005

grid = [[False for j in range(maxn)] for i in range(maxn)]
possibles = [[[False for j in range(maxn)] for i in range(maxn)],
             [[False for j in range(maxn)] for i in range(maxn)]]

line = sys.stdin.readline().strip().split(" ")
height = int(line[0])
width = int(line[1])
message = int(line[2])

for i in range(1, height + 1):
    row = sys.stdin.readline().strip();
    for j in range(width):
        if row[j] == '.':
            grid[i][j + 1] = True
        
for i in range(1, height + 1):
    possibles[1][i] = grid[i][:]

msg = sys.stdin.readline().strip()
for i in range(message):
    c = msg[i]
    if c == 'N':
        for k in range(1, height + 1):
            for j in range(1, width + 1):
                possibles[i % 2][k][j] = possibles[((i + 1) & 1)][k + 1][j] and grid[k][j]
    elif c == 'E':
        for k in range(1, height + 1):
            for j in range(1, width + 1):
                possibles[i % 2][k][j] = possibles[((i + 1) & 1)][k][j - 1] and grid[k][j]
    elif c == 'S':
        for k in range(1, height + 1):
            for j in range(1, width + 1):
                possibles[i % 2][k][j] = possibles[((i + 1) & 1)][k - 1][j] and grid[k][j]
    elif c == 'W':
        for k in range(1, height + 1):
            for j in range(1, width + 1):
                possibles[i % 2][k][j] = possibles[((i + 1) & 1)][k][j + 1] and grid[k][j]
    elif c == '?':
        for k in range(1, height + 1):
            for j in range(1, width + 1):
                possibles[i % 2][k][j] = (possibles[((i + 1) & 1)][k + 1][j] or
                                          possibles[((i + 1) & 1)][k][j - 1] or
                                          possibles[((i + 1) & 1)][k - 1][j] or
                                          possibles[((i + 1) & 1)][k][j + 1]) and grid[k][j]

ans = 0
for i in range(1, height + 1):
    for j in range(1, width + 1):
        ans += int(possibles[(message - 1) % 2][i][j])
    
print(ans)
