////!pragma
//const short ZERO = 3002;
//short bi,bj;
//short best_l[2*ZERO],best_r[2*ZERO];
//short solve(string s, string ls, string rs){
//    vi l = z_alg(ls+s);
//    reverse(all(s));
//    vi r = z_alg(rs+s);
//    for(int &x : l) x = min(x,int(sz(ls)));
//    for(int &x : r) x = min(x,int(sz(rs)));
//    l.erase(l.begin(),l.begin()+sz(ls));
//    r.erase(r.begin(),r.begin()+sz(rs));
//    reverse(all(r));
//    memset(best_l,0x9f,sizeof best_l); //set large negative value
//    memset(best_r,0x9f,sizeof best_r); //set large negative value
//    short n = sz(s);
//    short ans = 0;
//    for(short i = 0; i < n; ++i) best_l[l[i]+i] = max(best_l[l[i]+i],short(-i+1));
//    for(short j = 0; j < n; ++j) best_r[r[j]-j-1+ZERO] = max(best_r[r[j]-j-1+ZERO],j);
//    for(short i = 2*ZERO-2; i >= 0; --i) best_l[i] = max(best_l[i],best_l[i+1]);
//    for(short i = 2*ZERO-2; i >= 0; --i) best_r[i] = max(best_r[i],best_r[i+1]);
//    for(short x = 0; x < 2*ZERO; ++x){
//        short y = max(-x+ZERO,0);
//        if(ans < best_l[x]+best_r[y]){
//            ans = best_l[x]+best_r[y];
//            bi = -(best_l[x]-1);
//            //bj = best_r[y];
//            bj = r[best_r[y]];
//            //assert(0 <= bj && bj <= sz(ls)+sz(rs));
//            //watch(bi);
//            //watch(bj);
//        }
//    }
//    return ans;
//}
//void _(){
//    string s,t;
//    cin >> s >> t;
//    int ans = 0;
//    int best_i = 0, best_j = 0;
//    for(int times = 0; times < 2; ++times){
//        for(int right_size = 0; right_size <= sz(t); ++right_size){
//            string ls = t.substr(right_size);
//            string rs = t.substr(0,right_size);
//            reverse(all(rs));
//            solve(s,s,rs);
//            int cur_ans = solve(s,ls,rs);
//            if(cur_ans > ans){
//                //watch(bi);
//                //watch(bj);
//                //watch(right_size);
//                ans = cur_ans;
//                best_i = bi;
//                best_j = right_size-bj;
//                if(times)
//                    best_j = sz(t)-best_j-ans;
//            }
//        }
//        reverse(all(t)); //both cw and ccw are possible
//    }
//    print(ans);
//    cout << best_i << ' ' << best_j << '\n';
//}
#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#include <stack>
#include <cstring>
#include <set>
#include <iomanip>
#include <algorithm>
#include <cassert>
#include <vector>
#include <utility>
#include <iostream>
#include <string>
#define all(v) (v).begin(), (v).end()
#define sz(v) ll(v.size())
#define T1 template<typename T> static
using namespace std;
typedef long long ll;
typedef vector<int> vi;
T1 ostream& operator<<(ostream& stream, const vector<T>& t);
T1 istream& read(T, T, istream& = cin);
T1 void print(T x, string end = "\n"){
    cout << x << end;
}
T1 vector<int> z_alg(vector<T>& s){
    vector<int> z(sz(s));
    int n = sz(s);
    int L = 0, R = 0;
    for(int i = 1; i < n; i++){
        if(i > R){
            L = R = i;
            while(R < n && s[R - L] == s[R])
                R++;
            z[i] = R - L;
            R--;
        }else{
            int k = i - L;
            if(z[k] < R - i + 1)
                z[i] = z[k];
            else{
                L = i;
                while(R < n && s[R - L] == s[R])
                    R++;
                z[i] = R - L;
                R--;
            }
        }
    }
    z[0] = sz(s);
    return z;
}
static vector<int> z_alg(string s){
    vector<char> t(all(s));
    return z_alg(t);
}
//!pragma
const short ZERO = 3002;
short bi,bj;
short best_l[2*ZERO],best_r[2*ZERO];
short solve(string s, string ls, string rs){
    vi l = z_alg(ls+s);
    reverse(all(s));
    vi r = z_alg(rs+s);
    for(int &x : l) x = min(x,int(sz(ls)));
    for(int &x : r) x = min(x,int(sz(rs)));
    l.erase(l.begin(),l.begin()+sz(ls));
    r.erase(r.begin(),r.begin()+sz(rs));
    reverse(all(r));
    memset(best_l,0x9f,sizeof best_l); //set large negative value
    memset(best_r,0x9f,sizeof best_r); //set large negative value
    short n = sz(s);
    short ans = 0;
    for(short i = 0; i < n; ++i) best_l[l[i]+i] = max(best_l[l[i]+i],short(-i+1));
    for(short j = 0; j < n; ++j) best_r[r[j]-j-1+ZERO] = max(best_r[r[j]-j-1+ZERO],j);
    for(short i = 2*ZERO-2; i >= 0; --i) best_l[i] = max(best_l[i],best_l[i+1]);
    for(short i = 2*ZERO-2; i >= 0; --i) best_r[i] = max(best_r[i],best_r[i+1]);
    for(short x = 0; x < 2*ZERO; ++x){
        short y = max(-x+ZERO,0);
        if(ans < best_l[x]+best_r[y]){
            ans = best_l[x]+best_r[y];
            bi = -(best_l[x]-1);
            //bj = best_r[y];
            bj = r[best_r[y]];
            //assert(0 <= bj && bj <= sz(ls)+sz(rs));
            //watch(bi);
            //watch(bj);
        }
    }
    return ans;
}
void _(){
    string s,t;
    cin >> s >> t;
    int ans = 0;
    int best_i = 0, best_j = 0;
    for(int times = 0; times < 2; ++times){
        for(int right_size = 0; right_size <= sz(t); ++right_size){
            string ls = t.substr(right_size);
            string rs = t.substr(0,right_size);
            reverse(all(rs));
            solve(s,s,rs);
            int cur_ans = solve(s,ls,rs);
            if(cur_ans > ans){
                //watch(bi);
                //watch(bj);
                //watch(right_size);
                ans = cur_ans;
                best_i = bi;
                best_j = right_size-bj;
                if(times)
                    best_j = sz(t)-best_j-ans;
            }
        }
        reverse(all(t)); //both cw and ccw are possible
    }
    print(ans);
    cout << best_i << ' ' << best_j << '\n';
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(15);
        _();
    }
