//simple: time O(n^4)

#pragma GCC optimize("Ofast")

#include <algorithm>
#include <iostream>
#include <string>
#include <vector>

using namespace std;

int solve_noflip(string &a, string &b, int *loc) {
  string s[2] = {a, b};
  int n[2] = {a.size(), b.size()};
  int res = 0;
  for (int i = 0; i <= n[0]; ++i) {
    for (int j = 0; j <= n[1]; ++j) {
      int forw_back_len[2]{};
      int idx[2] = {i, j};
      for (int l = 0; l < 2; ++l) {
        for (int k = 1; idx[l] - k >= 0 && idx[!l] + k <= n[!l]; ++k) {
          int cur_idx[2];
          cur_idx[l] = idx[l] - k;
          cur_idx[!l] = idx[!l];
          for (int m = 0; m < k; ++m) {
            if (s[0][cur_idx[0]] == s[1][cur_idx[1]]) {
              ++cur_idx[0];
              ++cur_idx[1];
            } else {
              break;
            }
          }
          if (cur_idx[l] == idx[l]) forw_back_len[l] = k;
        }
      }
      if (forw_back_len[0] + forw_back_len[1] > res) {
        res = forw_back_len[0] + forw_back_len[1];
        loc[0] = i - forw_back_len[0];
        loc[1] = j - forw_back_len[1];
      }
    }
  }
  return res;
}

int solve(string &s, string &t, int *loc) {
  int loc_noflip[2];
  int res = solve_noflip(s, t, loc_noflip);
  reverse(t.begin(), t.end());
  int loc_flip[2];
  int res_flip = solve_noflip(s, t, loc_flip);
  if (res_flip > res) {
    res = res_flip;
    loc[0] = loc_flip[0];
    loc[1] = (int)t.size() - loc_flip[1] - res;
  } else {
    for (int i = 0; i < 2; ++i) loc[i] = loc_noflip[i];
  }
  return res;
}
const int nmax = 3e3+5;

char buf[nmax];

int main() {
  scanf("%s", buf);
  string s(buf);
  scanf("%s", buf);
  string t(buf);
  int loc[2];
  int res = solve(s, t, loc);
  cout << res << '\n';
  if (res) {
    cout << loc[0] << ' ' << loc[1] << '\n';
  }
  return 0;
}
