import sys
import time
import random
from array import array

mod = int(1e9 + 7)
mult = 257
nmax = int(3e3 + 5)

mult_pow = [1]
for i in range(nmax):
        mult_pow.append(mult_pow[-1]*mult%mod)

def solve_noflip(a, b, loc):
        c_end = time.clock()+7.45
        s = (array('b', (ord(x) for x in a)), array('b', (ord(x) for x in(b))))
        n = (len(a), len(b))
        l = [0, 0]
        r = [0, 0]
        res = 0
        while time.clock() < c_end:
                for i in range(2):
                        l[i] = random.randint(0, n[i]-1)
                        r[i] = l[i]
                if 2 * (min(l[0], l[1]) + min(n[0] - r[0], n[1] - r[1])) <= res: continue
                start = l[0] - 1
                ofs = l[1]-l[0]
                stop = max(-1, -ofs-1)
                for i in range(start, stop, -1):
                        if a[i] != b[i+ofs]:
                                l[0] = i+1 
                                l[1] = i+ofs+1
                                break
                if 2 * (r[0] - l[0] + min(n[0] - r[0], n[1] - r[1])) <= res: continue
                start = r[0]
                ofs = r[1] - r[0]
                stop = min(n[0], n[1]-ofs)
                for i in range(start, stop):
                        if a[i] != b[i+ofs]:
                                r[0] = i
                                r[1] = i+ofs
                                break
                length = r[0] - l[0]
                if 2 * length <= res: continue
                if length > res:
                        res = length
                        loc[0] = l[0]
                        loc[1] = l[1]
                if(length + min(n[0] - r[0], l[1]) > res):
                        maxlen = min(length, min(n[0] - r[0], l[1]))
                        if(length + min(n[0] - r[0], l[1]) - res < 20):
                                ofs = l[1]-maxlen-r[0]
                                for i in range(maxlen, res-length, -1):
                                        found = True
                                        for j in range(r[0], r[0]+i):
                                                if a[j] != b[j+ofs]:
                                                        found = False
                                                        break
                                        if(found):
                                                res = length + i
                                                loc[0] = l[0]
                                                loc[1] = l[1]-i
                                                break
                                        ofs += 1
                        else:
                                h = [0, 0]
                                for j in range(1, min(res-length, min(n[0] - r[0], l[1]))+1):
                                        h[0] = (h[0] + s[0][r[0] + j - 1] * mult_pow[j - 1]) % mod
                                        h[1] = (h[1] * mult + s[1][l[1] - j]) % mod
                                for j in range(res-length+1, maxlen+1):
                                        h[0] = (h[0] + s[0][r[0] + j - 1] * mult_pow[j - 1]) % mod
                                        h[1] = (h[1] * mult + s[1][l[1] - j]) % mod
                                        if h[0] == h[1]:
                                                res = length + j
                                                loc[0] = l[0]
                                                loc[1] = l[1] - j
                if(length + min(n[1] - r[1], l[0]) > res):
                        maxlen = min(length, min(n[1] - r[1], l[0]))
                        if(length + min(n[1] - r[1], l[0]) - res < 20):
                                ofs = l[0]-maxlen-r[1]
                                for i in range(maxlen, res-length, -1):
                                        found = True
                                        for j in range(r[1], r[1]+i):
                                                if a[j+ofs] != b[j]:
                                                        found = False
                                                        break
                                        if(found):
                                                res = length + i
                                                loc[0] = l[0]-i
                                                loc[1] = l[1]
                                                break
                                        ofs += 1
                        else:
                                h = [0, 0]
                                for j in range(1, min(res-length, min(n[1] - r[1], l[0]))+1):
                                        h[1] = (h[1] +s[1][r[1] + j - 1] * mult_pow[j - 1])%mod
                                        h[0] = (h[0]*mult+s[0][l[0] - j])%mod;
                                for j in range(res-length+1, maxlen+1):
                                        h[1] = (h[1] +s[1][r[1] + j - 1] * mult_pow[j - 1])%mod
                                        h[0] = (h[0]*mult+s[0][l[0] - j])%mod;
                                        if h[0] == h[1]:
                                                res = length + j
                                                loc[1] = l[1]
                                                loc[0] = l[0] - j
        return res

def solve(s, t, loc):
        loc_noflip = [0, 0]
        res = solve_noflip(s, t, loc_noflip)
        loc_flip = [0, 0]
        res_flip = solve_noflip(s, t[::-1], loc_flip)
        if res_flip > res:
                res = res_flip
                loc[0] = loc_flip[0]
                loc[1] = len(t) - loc_flip[1] - res
        else:
                loc[0] = loc_noflip[0]
                loc[1] = loc_noflip[1]
        return res

s = sys.stdin.readline().strip()
t = sys.stdin.readline().strip()
loc = [0, 0]
res = solve(s, t, loc)
sys.stdout.write('{0}\n'.format(res));
if res > 0:
        sys.stdout.write('{0} {1}\n'.format(loc[0], loc[1]))
