import sys
import time
import random
import array
from array import array

mod = int(1e9 + 9)
mult = 29
nmax = int(3e3 + 5)

mult_pow = [1]
for i in range(nmax):
	mult_pow.append(mult_pow[-1]*mult%mod)

def solve_noflip(a, b, loc):
	c_end = time.clock()+7.45
	s = (array('b', (ord(x) for x in a)), array('b', (ord(x) for x in(b))))
	sh = (array('l', [1]), array('l', [1]))
	for i in range(2):
		for j in s[i]:
			sh[i].append((sh[i][-1]*mult+j)%mod)
	n = (len(a), len(b))
	l = [0, 0]
	r = [0, 0]
	res = 0
	seen_l = set()
	while time.clock() < c_end:
		for i in range(2):
			l[i] = random.randint(0, n[i]-1)
			r[i] = l[i]
		if 2 * (min(l[0], l[1]) + min(n[0] - r[0], n[1] - r[1])) <= res: continue
		start = l[0] - 1
		ofs = l[1]-l[0]
		stop = max(-1, -ofs-1)
		for i in range(start, stop, -1):
			if a[i] != b[i+ofs]:
				l[0] = i+1 
				l[1] = i+ofs+1
				break
		if 2 * (r[0] - l[0] + min(n[0] - r[0], n[1] - r[1])) <= res: continue
		start = r[0]
		ofs = r[1] - r[0]
		stop = min(n[0], n[1]-ofs)
		for i in range(start, stop):
			if a[i] != b[i+ofs]:
				r[0] = i
				r[1] = i+ofs
				break
		length = r[0] - l[0]
		if 2 * length <= res: continue
		if(length > 50):
			if tuple(l) in seen_l:
				continue
			seen_l.add(tuple(l))
		if length > res:
			res = length
			loc[0] = l[0]
			loc[1] = l[1]
		if(length + min(n[0] - r[0], l[1]) > res):
			maxlen = min(length, min(n[0] - r[0], l[1]))
			start_len = res-length
			h = [sh[0][r[0]+start_len]-sh[0][r[0]]*mult_pow[start_len],
					sh[1][l[1]]-sh[1][l[1]-start_len]*mult_pow[start_len]]
			for j in range(res-length+1, maxlen+1):
				h[0] = (h[0] * mult + s[0][r[0] + j - 1]) % mod
				h[1] = (h[1] + s[1][l[1] - j] * mult_pow[j - 1]) % mod
				if h[0] == h[1]:
					res = length + j
					loc[0] = l[0]
					loc[1] = l[1] - j
		if(length + min(n[1] - r[1], l[0]) > res):
			maxlen = min(length, min(n[1] - r[1], l[0]))
			start_len = res-length
			h = [sh[0][l[0]]-sh[0][l[0]-start_len]*mult_pow[start_len],
					sh[1][r[1]+start_len]-sh[1][r[1]]*mult_pow[start_len]]
			for j in range(res-length+1, maxlen+1):
				h[1] = (h[1]*mult + s[1][r[1] + j - 1])%mod
				h[0] = (h[0] + s[0][l[0] - j] * mult_pow[j - 1])%mod;
				if h[0] == h[1]:
					res = length + j
					loc[1] = l[1]
					loc[0] = l[0] - j
	return res

def solve(s, t, loc):
	loc_noflip = [0, 0]
	res = solve_noflip(s, t, loc_noflip)
	loc_flip = [0, 0]
	res_flip = solve_noflip(s, t[::-1], loc_flip)
	if res_flip > res:
		res = res_flip
		loc[0] = loc_flip[0]
		loc[1] = len(t) - loc_flip[1] - res
	else:
		loc[0] = loc_noflip[0]
		loc[1] = loc_noflip[1]
	return res

s = sys.stdin.readline().strip()
t = sys.stdin.readline().strip()
loc = [0, 0]
res = solve(s, t, loc)
sys.stdout.write('{0}\n'.format(res));
if res > 0:
	sys.stdout.write('{0} {1}\n'.format(loc[0], loc[1]))
