import sys
N, K, INF = 10**5+5, 17, 10**18
sys.setrecursionlimit(N)

adj, cost = [[[] for i in range(N)] for j in range(2)]
st, is_shop, depth, root_dist, shop_dist = [[0 for i in range(N)] for j in range(5)]
par = [0 for i in range(N)]
n, s, q, e = [int(_) for _ in input().split()]
edges = []
def dfs(u, p = -1):
    shop_dist[u] = 0 if is_shop[u] else INF
    for i in range(len(adj[u])):
        v = adj[u][i]
        if v == p:
            continue
        par[v] = u
        depth[v] = depth[u]+1;
        root_dist[v] = root_dist[u]+cost[u][i]
        dfs(v,u)
        shop_dist[u] = min(shop_dist[u],shop_dist[v]+cost[u][i])
def opti(u, p = -1):
    while st[u] != e and shop_dist[st[u]] >= shop_dist[u]:
        st[u] = st[st[u]]
    for i in range(len(adj[u])):
        v = adj[u][i]
        if v == p:
            continue
        st[v] = u
        opti(v,u)
def prep_st():
    st[e] = e;
    opti(e);
def get_block(ind):
    u,v = edges[ind-1]
    return u if depth[u] > depth[v] else v
def solve(u, block):
    v = u
    ans = INF 
    while True:
        ans = min(ans,shop_dist[v])
        if v == e:
            return "escaped"
        if v == block:
            break
        v = par[v]
    if shop_dist[v] == INF:
        return "oo"
    return ans + root_dist[u]
for i in range(n-1):
    a,b,w = [int(_) for _ in input().split()]
    adj[a].append(b)
    adj[b].append(a)
    cost[a].append(w)
    cost[b].append(w)
    edges.append([a,b])
for i in range(s):
    is_shop[int(input())] = True
depth[e] = 1
dfs(e)
for i in range(1,n+1):
    if shop_dist[i] != INF:
        shop_dist[i] -= root_dist[i]
prep_st()
for i in range(q):
    ind,u = [int(x) for x in input().split()]
    block = get_block(ind)
    print(solve(u,block))
